/**
 * Der Vielfrass ist die Hauptfigur im Pacmanspiel.
 * 
 * @author Klasse 10bc 
 * @version 2013-10-14
 */
public class Vielfrass
{
    // Attribute
    private int positionX;
    private int positionY;
    private char blickrichtung;
    private boolean verwundbar;
    private Kreissektor bild;

    /**
     * Konstruktor.
     * Erzeuge einen Vielfrass, der links oben auf der Leinwand steht,
     * nach Osten blickt und verwundbar ist.
     */
    public Vielfrass()
    {
        /*
         * Erzeuge einen neuen Kreissektor und nenne ihn bild.
         */
        bild = new Kreissektor ();
        
        /*
         * Bringe das Bild des Vielfrasses in die Ausgangsposition.
         */
        bewegeNach (1, 1);
        blickeNachOsten ();
        werdeVerwundbar ();
    }

    /**
     * Lasse den Vielfrass nach Norden schauen.
     */
    public void blickeNachNorden ()
    {
        blickrichtung = 'N';

        bild.setzeAnfangswinkel (120);
    }

    /**
     * Lasse den Vielfrass nach Westen schauen.
     */
    public void blickeNachWesten ()
    {
        blickrichtung = 'W';

        bild.setzeAnfangswinkel (210);
    }

    /**
     * Lasse den Vielfrass nach Sueden schauen.
     */
    public void blickeNachSueden ()
    {
        blickrichtung = 'S';

        bild.setzeAnfangswinkel (300);
    }

    /**
     * Lasse den Vielfrass nach Osten schauen.
     */
    public void blickeNachOsten ()
    {
        blickrichtung = 'O';

        bild.setzeAnfangswinkel (30);
    }

    /**
     * Mache den Vielfrass unverwundbar.
     */
    public void werdeUnverwundbar ()
    {
        verwundbar = false;

        bild.setzeFarbe ("rot");
    }

    /**
     * Mache den Vielfrass verwundbar.
     */
    public void werdeVerwundbar ()
    {
        verwundbar = true;

        bild.setzeFarbe ("gelb");
    }

    /**
     * Drehe den Vielfrass um 90 Grad nach links.
     */
    public void dreheNachLinks ()
    {
        switch (blickrichtung)
        {
            case 'N': blickeNachWesten (); break;
            case 'W': blickeNachSueden (); break;
            case 'S': blickeNachOsten (); break;
            case 'O': blickeNachNorden (); break;
        }
    }

    /**
     * Drehe den Vielfrass um 90 Grad nach rechts.
     */
    public void dreheNachRechts ()
    {
        switch (blickrichtung)
        {
            case 'S': blickeNachWesten (); break;
            case 'O': blickeNachSueden (); break;
            case 'N': blickeNachOsten (); break;
            case 'W': blickeNachNorden (); break;
        }
    }

    /**
     * Gib die Blickrichtung auf die Konsole aus.
     */
    public void schreibeBlickrichtung ()
    {
        switch (blickrichtung)
        {
            case 'N': System.out.println ("Norden!"); break;
            case 'W': System.out.println ("Westen!"); break;
            case 'S': System.out.println ("Sden!"); break;
            case 'O': System.out.println ("Osten!"); break;
        }
    }

    /**
     * Bewege den Vielfra auf das Levelfeld (x|y).
     */
    public void bewegeNach (int x, int y)
    {
        positionX = x;
        positionY = y;

        bild.setzePosition (x*100 - 99, y*100 - 99);
    }

    /**
     * Bewege Dich um ein Levelfeld in Blickrichtung.
     */
    public void gehe ()
    {
        switch (blickrichtung)
        {
            case 'N': bewegeNach (positionX    , positionY - 1); break;
            case 'W': bewegeNach (positionX - 1, positionY    ); break;
            case 'S': bewegeNach (positionX    , positionY + 1); break;
            case 'O': bewegeNach (positionX + 1, positionY    ); break;
        }
    }

    /**
     * Bewege Dich um ein Levelfeld entgegen Deiner Blickrichtung.
     */
    public void geheRueckwaerts ()
    {
        switch (blickrichtung)
        {
            case 'N': bewegeNach (positionX    , positionY + 1); break;
            case 'W': bewegeNach (positionX + 1, positionY    ); break;
            case 'S': bewegeNach (positionX    , positionY - 1); break;
            case 'O': bewegeNach (positionX - 1, positionY    ); break;
        }
    }

    /**
     * Bewege Dich um ein Levelfeld in Blickrichtung, aber verlasse die
     * Leinwand nicht.
     */
    public void geheInnerhalb ()
    {
        switch (blickrichtung)
        {
            case 'N':
            if (positionY > 1)
            {
                bewegeNach (positionX    , positionY - 1); 
            }
            else
            {
                bewegeNach (positionX, Leinwand.gibLeinwand ().gibHoehe () / 100);
            }
            break;
            
            case 'W':
            if (positionX > 1)
            {
                bewegeNach (positionX - 1, positionY    );
            }
            else
            {
                bewegeNach (Leinwand.gibLeinwand ().gibBreite () / 100, positionY);
            }
            break;
            
            case 'S':
            if (positionY * 100 < Leinwand.gibLeinwand ().gibHoehe ())
            {
                bewegeNach (positionX    , positionY + 1);
            }
            else
            {
                bewegeNach (positionX, 1);
            }
            break;
            
            case 'O':
            if (positionX * 100 < Leinwand.gibLeinwand ().gibBreite ())
            {
                bewegeNach (positionX + 1, positionY);
            }
            else
            {
                bewegeNach (1, positionY);
            }
            break;
        }
    }
}